## vavoom 1.33

=== CMakeLists.txt ===
project(vavoom)

option(ENABLE_ZONE_DEBUG "Enable memory allocation debuging")

cmake_minimum_required(VERSION 2.4)
if(COMMAND cmake_policy)
	cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

if(NOT DEFINED DATADIR)
	set(DATADIR share/vavoom)
endif(NOT DEFINED DATADIR)
if(NOT DEFINED BINDIR)
	set(BINDIR bin)
endif(NOT DEFINED BINDIR)

#
#  **** Add debug / development flags ****
#

if(ENABLE_ZONE_DEBUG)
	add_definitions(-DZONE_DEBUG=1)
endif(ENABLE_ZONE_DEBUG)

#
#  **** Check for zlib ****
#

find_package(ZLIB REQUIRED)
include_directories(${ZLIB_INCLUDE_DIR})

#
#  **** Check for inttypes.h ****
#

find_path(INTTYPES_INCLUDE_DIR inttypes.h)
if(INTTYPES_INCLUDE_DIR)
	add_definitions(-DHAVE_INTTYPES_H=1)
endif(INTTYPES_INCLUDE_DIR)

#
#  **** Check for newtwork libraries ****
#

if(WIN32)
	set(NET_LIBRARIES wsock32)
else(WIN32)
	set(NET_LIBRARIES "")
#FIXME we need this on Solaris
#	AC_SEARCH_LIBS([recvfrom], [socket], [], [AC_ERROR([Library containing recvfrom not found])])
#	AC_SEARCH_LIBS([gethostbyname], [nsl], [], [AC_ERROR([Library containing gethostbyname not found])])
endif(WIN32)

add_subdirectory(libs)
add_subdirectory(utils)
add_subdirectory(source)
add_subdirectory(progs)
add_subdirectory(basev)
foreach(DIR ${EXTRA_SUBDIRS})
	add_subdirectory(${DIR})
endforeach(DIR)

if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/karena)
	add_subdirectory(karena)
endif(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/karena)
if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/koraxrpg)
	add_subdirectory(koraxrpg)
endif(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/koraxrpg)

# EXTRA_DIST = \
# 	autogen.sh \
# 	fixunix.sh \
# 	docs/changes.log \
# 	docs/changes1.log \
# 	docs/changes2.log \
# 	docs/changes3.log \
# 	docs/gnu.txt \
# 	docs/vavoom.txt \
# 	docs/vcc.log \
# 	msvc/Vavoom.sln \
# 	msvc/acc.vcproj \
# 	msvc/libglbsp.vcproj \
# 	msvc/libglvis.vcproj \
# 	msvc/progs_common.vcproj \
# 	msvc/progs_doom.vcproj \
# 	msvc/progs_doom2.vcproj \
# 	msvc/progs_heretic.vcproj \
# 	msvc/progs_hexen.vcproj \
# 	msvc/progs_strife.vcproj \
# 	msvc/timidity.vcproj \
# 	msvc/vavoom.vcproj \
# 	msvc/vcc.vcproj \
# 	msvc/vlumpy.vcproj

# [1.26])
# 
# dnl
# dnl  **** Supported --enable arguments ****
# dnl
# 
# AC_ARG_ENABLE([debug], AS_HELP_STRING([--enable-debug], [Enable debuging]))
# 
# dnl
# dnl  **** Basic checks ****
# dnl
# 
# if test "x$enable_debug" = "xyes"; then
# 	CFLAGS="$CFLAGS -W -Wall"
# 	CXXFLAGS="$CXXFLAGS -W -Wall"
# 	LDFLAGS="$LDFLAGS -W -Wall"
# fi
# 
# case $host in
# *-*-mingw32* | *-*-cygwin* | *-*-windows*)
# 	CFLAGS="-mno-cygwin $CFLAGS"
# 	CXXFLAGS="-mno-cygwin $CXXFLAGS"
# 	LDFLAGS="-mno-cygwin $LDFLAGS"
# 	;;
# esac
# 
# dnl
# dnl  **** Check wehter we need to use libm ****
# dnl
# 
# AC_SEARCH_LIBS([sin], [m], [], [AC_ERROR([Library containing sin not found])])

=== basev/CMakeLists.txt ===
get_target_property(VLUMPY vlumpy LOCATION)
get_target_property(ACC acc LOCATION)

add_subdirectory(common)
add_subdirectory(doom)
add_subdirectory(doom1)
add_subdirectory(doom2)
add_subdirectory(heretic)
add_subdirectory(hexen)
add_subdirectory(plutonia)
add_subdirectory(strife)
add_subdirectory(tnt)

install(FILES games.txt DESTINATION ${DATADIR}/basev)

=== progs/CMakeLists.txt ===
get_target_property(VCC vcc LOCATION)

add_subdirectory(common)
add_subdirectory(doom)
add_subdirectory(doom2)
add_subdirectory(heretic)
add_subdirectory(hexen)
add_subdirectory(strife)

=== source/CMakeLists.txt ===
add_subdirectory(timidity)

option(WITH_ALLEGRO "Use Allegro library")
option(WITH_SDL "Use SDL library")
option(WITH_OPENGL "Use OpenGL library" ON)
option(WITH_OPENAL "Use OpenAL library" ON)
option(WITH_VORBIS "Enable Vorbis support" ON)
option(WITH_LIBMAD "Enable MP3 support" ON)
option(WITH_MIKMOD "Enable MikMod support" ON)
option(WITH_FLAC "Enable FLAC support" ON)

option(ENABLE_CLIENT "Build client executable" ON)
option(ENABLE_SERVER "Build dedicated server executable" ON)
if(UNIX)
option(ENABLE_WRAPPERS "Enable creation of wrapper scripts" ON)
endif(UNIX)

#---------------------------------------
#
#	Main executable sources
#
#---------------------------------------

#-- Common files --
set(MAIN_COMMON_SOURCES
	am_map.cpp
	anorm_dots.h
	anorms.h
	automap.h
	build.h
	chat.cpp
	chat.h
	cheats.cpp
	client.h
	cl_local.h
	cl_main.cpp
	cmd.cpp
	cmd.h
	common.h
	console.cpp
	console.h
	cvar.cpp
	cvar.h
	debug.cpp
	debug.h
	drawer.h
	files.cpp
	files.h
	finale.cpp
	finale.h
	fmd2defs.h
	fs_local.h
	fs_dir.cpp
	fs_wad.cpp
	fs_zip.cpp
	fwaddefs.h
	gamedefs.h
	host.cpp
	host.h
	iline.cpp
	iline.h
	in_input.cpp
	infostr.cpp
	infostr.h
	input.h
	l_glbsp.cpp
	l_glvis.cpp
	language.cpp
	language.h
	level.cpp
	level.h
	lockdefs.cpp
	lockdefs.h
	mapinfo.cpp
	mapinfo.h
	maths.cpp
	maths.h
	menu.cpp
	menu.h
	misc.cpp
	misc.h
	net_channel.cpp
	net_channel_control.cpp
	net_channel_level.cpp
	net_channel_object_map.cpp
	net_channel_player.cpp
	net_channel_thinker.cpp
	net_connection.cpp
	net_context.cpp
	net_datagram.cpp
	net_demo.cpp
	net_local.h
	net_loopback.cpp
	net_main.cpp
	net_message.cpp
	net_message.h
	net_object_map.cpp
	network.h
	p_acs.cpp
	p_acs.h
	p_clip.cpp
	p_clip.h
	p_entity.cpp
	p_entity.h
	p_entity_sight.cpp
	p_entity_world.cpp
	p_gameinfo.cpp
	p_gameinfo.h
	p_gameobject.cpp
	p_gameobject.h
	p_level_think.cpp
	p_levelinfo.cpp
	p_levelinfo.h
	p_nodebuild.cpp
	p_player.cpp
	p_player.h
	p_player_input.cpp
	p_playerreplicationinfo.cpp
	p_playerreplicationinfo.h
	p_polyobj.cpp
	p_setup.cpp
	p_setup_udmf.cpp
	p_switch.cpp
	p_terrain.cpp
	p_thinker.cpp
	p_thinker.h
	p_trace.cpp
	p_world.cpp
	p_world.h
	p_worldinfo.cpp
	p_worldinfo.h
	pr_cmds.cpp
	pr_exec.cpp
	progdefs.h
	progs.h
	r_adv_light.cpp
	r_adv_things.cpp
	r_bsp.cpp
	r_data.cpp
	r_light.cpp
	r_local.h
	r_main.cpp
	r_model.cpp
	r_particle.cpp
	r_portal.cpp
	r_public.h
	r_shared.h
	r_sky.cpp
	r_surf.cpp
	r_tex.cpp
	r_tex.h
	r_tex_automap.cpp
	r_tex_base.cpp
	r_tex_camera.cpp
	r_tex_flat.cpp
	r_tex_imgz.cpp
	r_tex_jpeg.cpp
	r_tex_multipatch.cpp
	r_tex_patch.cpp
	r_tex_pcx.cpp
	r_tex_png.cpp
	r_tex_raw.cpp
	r_tex_tga.cpp
	r_tex_warp.cpp
	r_things.cpp
	save.h
	sbar.cpp
	sbar.h
	sc_man.cpp
	screen.cpp
	screen.h
	scripts.h
	server.h
	snd_data.cpp
	snd_local.h
	snd_main.cpp
	snd_qmus2mid.cpp
	snd_reverbs.cpp
	snd_streamplayer.cpp
	snd_timidity.cpp
	snd_wav.cpp
	sound.h
	sv_local.h
	sv_main.cpp
	sv_save.cpp
	sv_world.cpp
	system.h
	text.cpp
	text.h
	ui.h
	ui_actor.cpp
	ui_font.cpp
	ui_font.h
	ui_root.cpp
	ui_root.h
	ui_widget.cpp
	ui_widget.h
	vc_class.cpp
	vc_class.h
	vc_constant.cpp
	vc_constant.h
	vc_decorate.cpp
	vc_decorate.h
	vc_dehacked.cpp
	vc_dehacked.h
	vc_emit_context.cpp
	vc_emit_context.h
	vc_error.cpp
	vc_error.h
	vc_expr_array.cpp
	vc_expr_array.h
	vc_expr_assign.cpp
	vc_expr_assign.h
	vc_expr_base.cpp
	vc_expr_base.h
	vc_expr_cast.cpp
	vc_expr_cast.h
	vc_expr_field.cpp
	vc_expr_field.h
	vc_expr_invoke.cpp
	vc_expr_invoke.h
	vc_expr_literal.cpp
	vc_expr_literal.h
	vc_expr_local.cpp
	vc_expr_local.h
	vc_expr_misc.cpp
	vc_expr_misc.h
	vc_expr_type.cpp
	vc_expr_type.h
	vc_expr_unary_binary.cpp
	vc_expr_unary_binary.h
	vc_field.cpp
	vc_field.h
	vc_lexer.cpp
	vc_lexer.h
	vc_location.cpp
	vc_location.h
	vc_member.cpp
	vc_member.h
	vc_method.cpp
	vc_method.h
	vc_modifiers.cpp
	vc_modifiers.h
	vc_object.cpp
	vc_object.h
	vc_package.cpp
	vc_package.h
	vc_parser.cpp
	vc_parser.h
	vc_property.cpp
	vc_property.h
	vc_state.cpp
	vc_state.h
	vc_statement.cpp
	vc_statement.h
	vc_struct.cpp
	vc_struct.h
	vc_type.cpp
	vc_type.h
	video.h
	wad.cpp
	wad.h
	zipstream.cpp
	zipstream.h
)

#-- Common OpenGL files --
set(MAIN_OPENGL_SOURCES
	gl_draw.cpp
	gl_local.h
	gl_main.cpp
	gl_model.cpp
	gl_poly.cpp
	gl_tex.cpp
)

#-- OpenAL files --
set(MAIN_OPENAL_SOURCES
	snd_al.cpp
)

#-- Vorbis files --
set(MAIN_VORBIS_SOURCES
	snd_vorbis.cpp
)

#-- MP3 files --
set(MAIN_MP3_SOURCES
	snd_mp3.cpp
)

#-- MikMod files --
set(MAIN_MIKMOD_SOURCES
	snd_mikmod.cpp
)

#-- FLAC files --
set(MAIN_FLAC_SOURCES
	snd_flac.cpp
)

#-- Linux with Allegro --
set(MAIN_UNIX_ALLEGRO_SOURCES
	in_alleg.cpp
	net_udp.cpp
	snd_allegro.cpp
	snd_allegromusic.cpp
	sys_lin.cpp
)
set(MAIN_OPENGL_UNIX_ALLEGRO_SOURCES
	gl_agl.cpp
)

#-- Linux with SDL --
set(MAIN_UNIX_SDL_SOURCES
	in_sdl.cpp
	net_udp.cpp
	snd_sdl.cpp
	snd_sdlmusic.cpp
	sys_sdl.cpp
)
set(MAIN_OPENGL_UNIX_SDL_SOURCES
	gl_sdl.cpp
)

#-- CD audio drivers for various UNIX platforms --
set(MAIN_CDAUDIO_LINUX_SOURCES
	snd_audiocd_linux.cpp
)
set(MAIN_CDAUDIO_BSD_SOURCES
	snd_audiocd_bsd.cpp
)

#-- Windows --
set(MAIN_WIN32_SOURCES
	d3d_draw.cpp
	d3d_local.h
	d3d_main.cpp
	d3d_poly.cpp
	d3d_tex.cpp
	eax.h
	in_win32.cpp
	net_winsock.cpp
	snd_audiocd_win32.cpp
	snd_win32.cpp
	snd_win32music.cpp
	sys_win.cpp
	vavoom.ico
	vavoom_2.ico
	vavoom_3.ico
	vavoom.rc
	winlocal.h
)
set(MAIN_OPENGL_WIN32_SOURCES
	gl_win32.cpp
)

#---------------------------------------
#
#	Dedicated server sources
#
#---------------------------------------

set(SERVER_COMMON_SOURCES
	cheats.cpp
	cmd.cpp
	cvar.cpp
	debug.cpp
	files.cpp
	fs_dir.cpp
	fs_wad.cpp
	fs_zip.cpp
	host.cpp
	infostr.cpp
	language.cpp
	level.cpp
	lockdefs.cpp
	mapinfo.cpp
	maths.cpp
	misc.cpp
	net_channel.cpp
	net_channel_control.cpp
	net_channel_level.cpp
	net_channel_object_map.cpp
	net_channel_player.cpp
	net_channel_thinker.cpp
	net_connection.cpp
	net_context.cpp
	net_datagram.cpp
	net_demo.cpp
	net_loopback.cpp
	net_main.cpp
	net_message.cpp
	net_object_map.cpp
	p_acs.cpp
	p_clip.cpp
	p_entity.cpp
	p_entity_sight.cpp
	p_entity_world.cpp
	p_gameinfo.cpp
	p_gameobject.cpp
	p_level_think.cpp
	p_levelinfo.cpp
	p_nodebuild.cpp
	p_player.cpp
	p_player_input.cpp
	p_playerreplicationinfo.cpp
	p_polyobj.cpp
	p_setup.cpp
	p_setup_udmf.cpp
	p_switch.cpp
	p_terrain.cpp
	p_thinker.cpp
	p_trace.cpp
	p_world.cpp
	p_worldinfo.cpp
	pr_cmds.cpp
	pr_exec.cpp
	r_data.cpp
	r_tex.cpp
	r_tex_automap.cpp
	r_tex_base.cpp
	r_tex_camera.cpp
	r_tex_flat.cpp
	r_tex_imgz.cpp
	r_tex_jpeg.cpp
	r_tex_multipatch.cpp
	r_tex_patch.cpp
	r_tex_pcx.cpp
	r_tex_png.cpp
	r_tex_raw.cpp
	r_tex_tga.cpp
	r_tex_warp.cpp
	snd_data.cpp
	snd_reverbs.cpp
	sc_man.cpp
	sv_main.cpp
	sv_save.cpp
	sv_world.cpp
	vc_class.cpp
	vc_constant.cpp
	vc_decorate.cpp
	vc_dehacked.cpp
	vc_emit_context.cpp
	vc_error.cpp
	vc_expr_array.cpp
	vc_expr_assign.cpp
	vc_expr_base.cpp
	vc_expr_cast.cpp
	vc_expr_field.cpp
	vc_expr_invoke.cpp
	vc_expr_literal.cpp
	vc_expr_local.cpp
	vc_expr_misc.cpp
	vc_expr_type.cpp
	vc_expr_unary_binary.cpp
	vc_field.cpp
	vc_lexer.cpp
	vc_location.cpp
	vc_member.cpp
	vc_method.cpp
	vc_modifiers.cpp
	vc_object.cpp
	vc_package.cpp
	vc_parser.cpp
	vc_property.cpp
	vc_state.cpp
	vc_statement.cpp
	vc_struct.cpp
	vc_type.cpp
	wad.cpp
	zipstream.cpp
)

set(SERVER_UNIX_SOURCES
	net_udp.cpp
	sys_bsd.cpp
)

set(SERVER_WIN32_SOURCES
	net_winsock.cpp
	sys_wind.cpp
	vavoom.rc
)

#---------------------------------------
#
#	svnrev.h stuff
#
#---------------------------------------

add_custom_target( revision_check ALL
	COMMAND updaterevision ${PROJECT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR}/svnrev.h
	WORKING_DIRECTORY ${UPDATEREVISION_EXE}
	DEPENDS updaterevision )

include_directories(${CMAKE_CURRENT_BINARY_DIR})

#---------------------------------------
#
#	Main executable
#
#---------------------------------------

if(ENABLE_CLIENT)

set(MAIN_SOURCES ${MAIN_COMMON_SOURCES})
set(MAIN_LIBS glbsp libglvis timidity core ${ZLIB_LIBRARY} ${NET_LIBRARIES})
set(MAIN_COMPILE_FLAGS "")

#
#  **** Platform specific library checks ****
#

if(WIN32)
	# ---------------- Windows ----------------
	set(MAIN_SOURCES ${MAIN_SOURCES} ${MAIN_WIN32_SOURCES})
	set(MAIN_LIBS gdi32 ole32 winmm ${MAIN_LIBS})

	#  CMake doesn't support automatic building of resource files so
	# we must add a custom command and add object files to the list
	# of source files
	set(RC_SRC ${CMAKE_CURRENT_SOURCE_DIR}/vavoom.rc)
	set(RC_OBJ ${CMAKE_CURRENT_BINARY_DIR}/vavoom.o)
	add_custom_command(OUTPUT ${RC_OBJ}
		DEPENDS ${RC_SRC}
		COMMAND windres --include-dir=${CMAKE_CURRENT_SOURCE_DIR} --include-dir=${CMAKE_CURRENT_BINARY_DIR} -o ${RC_OBJ} -i ${RC_SRC}
	)
	set(MAIN_SOURCES ${MAIN_SOURCES} ${RC_OBJ})

	if(WITH_OPENGL)
		set(MAIN_SOURCES ${MAIN_SOURCES} ${MAIN_OPENGL_SOURCES} ${MAIN_OPENGL_WIN32_SOURCES})
		set(MAIN_LIBS opengl32 ${MAIN_LIBS})
	endif(WITH_OPENGL)

	if(WITH_OPENAL)
		find_path(OPENALAL_INCLUDE_DIR AL/al.h)
		set(MAIN_SOURCES ${MAIN_SOURCES} ${MAIN_OPENAL_SOURCES})
		set(MAIN_LIBS OpenAL32 ${MAIN_LIBS})
	endif(WITH_OPENAL)
else(WIN32)
	# ---------------- Other *NIX platforms ----------------
	if(NOT DEFINED ALLEGRO_CONFIG)
		set(ALLEGRO_CONFIG allegro-config)
	endif(NOT DEFINED ALLEGRO_CONFIG)

	if(WITH_ALLEGRO)
		find_program(ALLEGRO_CONFIG_EXECUTABLE ${ALLEGRO_CONFIG})
		if(NOT ALLEGRO_CONFIG_EXECUTABLE)
			message(FATAL_ERROR "Cannot find Allegro instalation")
		endif(NOT ALLEGRO_CONFIG_EXECUTABLE)
		set(ALLEGRO_FOUND TRUE)
	elseif(WITH_SDL)
		find_package(SDL REQUIRED)
	else(WITH_ALLEGRO)
		find_package(SDL)
		if(NOT SDL_FOUND)
			find_program(ALLEGRO_CONFIG_EXECUTABLE ${ALLEGRO_CONFIG})
			if(ALLEGRO_CONFIG_EXECUTABLE)
				set(ALLEGRO_FOUND TRUE)
			endif(ALLEGRO_CONFIG_EXECUTABLE)
		endif(NOT SDL_FOUND)
	endif(WITH_ALLEGRO)

	if(ALLEGRO_FOUND)
		message(STATUS "Using Allegro")
		# run the allegro-config program to get cxxflags
		exec_program(sh
			ARGS "${ALLEGRO_CONFIG_EXECUTABLE} --cflags"
			OUTPUT_VARIABLE ALLEGRO_CXX_FLAGS
			RETURN_VALUE RET)
		if(RET EQUAL 0)
			# parse definitions from cxxflags
			string(REGEX MATCHALL "-D.*[^ ;]+" ALLEGRO_DEFINITIONS ${ALLEGRO_CXX_FLAGS})
			# drop -D* from CXXFLAGS
			string(REGEX REPLACE "-D[^ ;]*" "" ALLEGRO_CXX_FLAGS ${ALLEGRO_CXX_FLAGS})
			# parse incdirs from cxxflags, drop -I prefix
			string(REGEX MATCHALL "-I.*[^ ;]+" ALLEGRO_INCLUDE_DIRS ${ALLEGRO_CXX_FLAGS})
			string(REGEX REPLACE "-I" "" ALLEGRO_INCLUDE_DIRS "${ALLEGRO_CXX_FLAGS}")
			# convert space to semicolons for list
			string(REGEX REPLACE " " ";" ALLEGRO_INCLUDE_DIRS "${ALLEGRO_INCLUDE_DIRS}")
		endif(RET EQUAL 0)

		# run the allegro-config program to get the libs
		exec_program(sh
			ARGS "${ALLEGRO_CONFIG_EXECUTABLE} --libs"
			OUTPUT_VARIABLE ALLEGRO_LIBRARIES
			RETURN_VALUE RET)
		if(RET EQUAL 0)
			string(REGEX REPLACE " " ";" ALLEGRO_LIBRARIES "${ALLEGRO_LIBRARIES}")
			# extract linkdirs (-L) for rpath (i.e., LINK_DIRECTORIES)
			string(REGEX MATCHALL "-L[^ ;]+" ALLEGRO_LIBRARY_DIRS "${ALLEGRO_LIBRARIES}")
			string(REGEX REPLACE "-L" "" ALLEGRO_LIBRARY_DIRS "${ALLEGRO_LIBRARY_DIRS}")
			# convert space to semicolons for list
			STRING(REGEX REPLACE " " ";" ALLEGRO_LIBRARY_DIRS "${ALLEGRO_LIBRARY_DIRS}")
		endif(RET EQUAL 0)

		include_directories(${ALLEGRO_INCLUDE_DIRS})
		set(MAIN_SOURCES ${MAIN_SOURCES} ${MAIN_UNIX_ALLEGRO_SOURCES})
		set(MAIN_LIBS ${ALLEGRO_LIBRARIES} ${MAIN_LIBS})
	elseif(SDL_FOUND)
		message(STATUS "Using SDL")
		find_package(SDL_mixer REQUIRED)
		include_directories(${SDL_INCLUDE_DIR})
		set(MAIN_SOURCES ${MAIN_SOURCES} ${MAIN_UNIX_SDL_SOURCES})
		set(MAIN_LIBS ${SDLMIXER_LIBRARY} ${SDL_LIBRARY} ${MAIN_LIBS})
	else(ALLEGRO_FOUND)
		message(FATAL_ERROR "Vavoom requires Allegro or SDL to compile")
	endif(ALLEGRO_FOUND)

	find_path(LINUX_CDROM_INCLUDE_DIR linux/cdrom.h)
	if(LINUX_CDROM_INCLUDE_DIR)
		message(STATUS "Using LINUX CD-ROM API")
		set(MAIN_SOURCES ${MAIN_SOURCES} ${MAIN_CDAUDIO_LINUX_SOURCES})
	else(LINUX_CDROM_INCLUDE_DIR)
		find_path(BSD_CDIO_INCLUDE_DIR sys/cdio.h)

=== utils/CMakeLists.txt ===
option(ENABLE_LAUNCHER "Build launcher" ON)
option(ENABLE_MASTER "Build master server" OFF)

file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/bin)

add_subdirectory(acc)
add_subdirectory(fixmd2)
add_subdirectory(glbsp)
add_subdirectory(glvis)
add_subdirectory(master)
add_subdirectory(updaterevision)
add_subdirectory(vcc)
add_subdirectory(vlaunch)
add_subdirectory(vlumpy)

# EXTRA_DIST = \
# 	editing/acs/strfhelp.acs \
# 	editing/acs/stspec.acs \
# 	editing/acs/vcommon.acs \
# 	editing/acs/vdefs.acs \
# 	editing/acs/vspecial.acs \
# 	editing/acs/vwvars.acs \
# 	editing/dbuilder/Vavoom_Doom.cfg \
# 	editing/dbuilder/Vavoom_Doom2.cfg \
# 	editing/dbuilder/Vavoom_Heretic.cfg \
# 	editing/dbuilder/Vavoom_Hexen.cfg \
# 	editing/dbuilder/Vavoom_Strife.cfg \
# 	editing/wauthor/vdoom.wcf \
# 	editing/wauthor/vdoom2.wcf \
# 	editing/wauthor/vheretic.wcf \
# 	editing/wauthor/vhexen.wcf \
# 	editing/wauthor/vstrife.wcf

=== basev/common/CMakeLists.txt ===
configure_file(basepak.ls.in ${CMAKE_CURRENT_BINARY_DIR}/basepak.ls)

add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/basepak.pk3
	COMMAND ${VLUMPY} ARGS basepak.ls
	DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/basepak.ls vlumpy
		basepak.ls.in
		confont.pcx
		decorate.txt
		default.cfg
		in_epi1.txt
		in_epi2.txt
		in_epi3.txt
		in_htc1.txt
		in_htc2.txt
		in_htc3.txt
		language.en
		line_specials.txt
		lockdefs.txt
		reverbs.txt
		startup.vs
		terrain.txt
		textcolo.txt
		vavoom_decorate_defs.xml
		vfxdefs.txt
		x11r6rgb.txt
		actors/constants.txt
		actors/nativeclasses.txt
		actors/doom/arachnotron.txt
		actors/doom/archvile.txt
		actors/doom/bossbrain.txt
		actors/doom/bruiser.txt
		actors/doom/cacodemon.txt
		actors/doom/cyberdemon.txt
		actors/doom/deadthings.txt
		actors/doom/demon.txt
		actors/doom/doomammo.txt
		actors/doom/doomarmor.txt
		actors/doom/doomartifacts.txt
		actors/doom/doomdecorations.txt
		actors/doom/doomhealth.txt
		actors/doom/doomimp.txt
		actors/doom/doomkeys.txt
		actors/doom/doommisc.txt
		actors/doom/doomplayer.txt
		actors/doom/doomweapons.txt
		actors/doom/fatso.txt
		actors/doom/keen.txt
		actors/doom/lostsoul.txt
		actors/doom/painelemental.txt
		actors/doom/possessed.txt
		actors/doom/revenant.txt
		actors/doom/scriptedmarine.txt
		actors/doom/spidermaster.txt
		actors/doom/stealthmonsters.txt
		actors/heretic/beast.txt
		actors/heretic/chicken.txt
		actors/heretic/clink.txt
		actors/heretic/dsparil.txt
		actors/heretic/hereticammo.txt
		actors/heretic/hereticarmor.txt
		actors/heretic/hereticartifacts.txt
		actors/heretic/hereticdecorations.txt
		actors/heretic/hereticimp.txt
		actors/heretic/heretickeys.txt
		actors/heretic/hereticmisc.txt
		actors/heretic/hereticplayer.txt
		actors/heretic/hereticweaps.txt
		actors/heretic/ironlich.txt
		actors/heretic/knight.txt
		actors/heretic/mummy.txt
		actors/heretic/snake.txt
		actors/heretic/wizard.txt
		actors/hexen/bats.txt
		actors/hexen/bishop.txt
		actors/hexen/blastradius.txt
		actors/hexen/centaur.txt
		actors/hexen/clericboss.txt
		actors/hexen/clericflame.txt
		actors/hexen/clericholy.txt
		actors/hexen/clericmace.txt
		actors/hexen/clericstaff.txt
		actors/hexen/clericplayer.txt
		actors/hexen/demons.txt
		actors/hexen/dragon.txt
		actors/hexen/ettin.txt
		actors/hexen/fighteraxe.txt
		actors/hexen/fighterboss.txt
		actors/hexen/fighterfist.txt
		actors/hexen/fighterhammer.txt
		actors/hexen/fighterplayer.txt
		actors/hexen/fighterquietus.txt
		actors/hexen/firedemon.txt
		actors/hexen/flame.txt
		actors/hexen/flechette.txt
		actors/hexen/fog.txt
		actors/hexen/heresiarch.txt
		actors/hexen/hexenarmor.txt
		actors/hexen/hexendecorations.txt
		actors/hexen/hexenkeys.txt
		actors/hexen/hexenspecialdecs.txt
		actors/hexen/iceguy.txt
		actors/hexen/korax.txt
		actors/hexen/mageboss.txt
		actors/hexen/magecone.txt
		actors/hexen/magelightning.txt
		actors/hexen/mageplayer.txt
		actors/hexen/magestaff.txt
		actors/hexen/magewand.txt
		actors/hexen/mana.txt
		actors/hexen/pig.txt
		actors/hexen/puzzleitems.txt
		actors/hexen/scriptprojectiles.txt
		actors/hexen/serpent.txt
		actors/hexen/speedboots.txt
		actors/hexen/spike.txt
		actors/hexen/summon.txt
		actors/hexen/teleportother.txt
		actors/hexen/wraith.txt
		actors/raven/artiegg.txt
		actors/raven/minotaur.txt
		actors/raven/ravenambient.txt
		actors/raven/ravenartifacts.txt
		actors/raven/ravenhealth.txt
		actors/shared/blood.txt
		actors/shared/debris.txt
		actors/shared/fountain.txt
		actors/shared/pickups.txt
		actors/shared/sharedmisc.txt
		actors/shared/soundsequence.txt
		actors/shared/splashes.txt
		actors/strife/acolyte.txt
		actors/strife/alienspectres.txt
		actors/strife/beggars.txt
		actors/strife/coin.txt
		actors/strife/crusader.txt
		actors/strife/entityboss.txt
		actors/strife/inquisitor.txt
		actors/strife/loremaster.txt
		actors/strife/macil.txt
		actors/strife/merchants.txt
		actors/strife/peasants.txt
		actors/strife/programmer.txt
		actors/strife/questitems.txt
		actors/strife/ratbuddy.txt
		actors/strife/reaver.txt
		actors/strife/rebels.txt
		actors/strife/sentinel.txt
		actors/strife/sigil.txt
		actors/strife/spectral.txt
		actors/strife/stalker.txt
		actors/strife/strifeammo.txt
		actors/strife/strifearmor.txt
		actors/strife/strifebishop.txt
		actors/strife/strifehumanoid.txt
		actors/strife/strifeitems.txt
		actors/strife/strifekeys.txt
		actors/strife/strifeplayer.txt
		actors/strife/strifestuff.txt
		actors/strife/strifeweapons.txt
		actors/strife/templar.txt
		actors/strife/thingstoblowup.txt
		actors/strife/zombie.txt
		fxdefs/common/effects.txt
		fxdefs/doom/decorations.txt
		fxdefs/doom/monsters.txt
		fxdefs/doom/pickups.txt
		fxdefs/doom/weapons.txt
		fxdefs/heretic/decorations.txt
		fxdefs/heretic/effects.txt
		fxdefs/heretic/monsters.txt
		fxdefs/heretic/pickups.txt
		fxdefs/heretic/weapons.txt
		fxdefs/hexen/decorations.txt
		fxdefs/hexen/effects.txt
		fxdefs/hexen/monsters.txt
		fxdefs/hexen/pickups.txt
		fxdefs/hexen/projectiles.txt
		fxdefs/hexen/weapons.txt
		fxdefs/raven/minotaur.txt
		fxdefs/raven/pickups.txt
		fxdefs/strife/decorations.txt
		fxdefs/strife/monsters.txt
		fxdefs/strife/weapons.txt
		graphics/mc_arrow.png
		sounds/dsempty.lmp
		sounds/dsquake.flac
		sounds/icebrk1a.flac
		sounds/icedth1.flac
		sounds/railgf1.flac
		sounds/spark1.flac
		sounds/spark2.flac
		sounds/spark3.flac
		sprites/iceca0.png
		sprites/icecb0.png
		sprites/icecc0.png
		sprites/icecd0.png
		sprites/tnt1a0.lmp
		sprites/unkna0.png
		textures/-noflat-.png
		${CMAKE_SOURCE_DIR}/progs/common/engine/*.vc
		${CMAKE_SOURCE_DIR}/progs/common/linespec/*.vc
		${CMAKE_SOURCE_DIR}/progs/common/uibase/*.vc
		${CMAKE_CURRENT_SOURCE_DIR}/glshaders/*.fs
		${CMAKE_CURRENT_SOURCE_DIR}/glshaders/*.vs
	)
add_custom_target(common_basepak ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/basepak.pk3)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/basepak.pk3
	DESTINATION ${DATADIR}/basev/common)

=== basev/doom/CMakeLists.txt ===
configure_file(basepak.ls.in ${CMAKE_CURRENT_BINARY_DIR}/basepak.ls)

add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/basepak.pk3
	COMMAND ${VLUMPY} ARGS basepak.ls
	DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/basepak.ls vlumpy
		graphics/autopage.lmp
		graphics/croshai1.lmp
		graphics/croshai2.lmp
		graphics/croshai3.lmp
		basepak.ls.in
		bigfont.pcx
		animated.lmp
		animdefs.txt
		dehinfo.txt
		lockdefs.txt
		mapinfo.txt
		palette.pcx
		skyboxes.txt
		sndinfo.txt
		sndseq.txt
		${CMAKE_SOURCE_DIR}/progs/doom/cgame/*.vc
		${CMAKE_SOURCE_DIR}/progs/doom/game/*.vc
	)
add_custom_target(doom_basepak ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/basepak.pk3)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/basepak.pk3
	DESTINATION ${DATADIR}/basev/doom)

=== basev/doom1/CMakeLists.txt ===
configure_file(basepak.ls.in ${CMAKE_CURRENT_BINARY_DIR}/basepak.ls)

add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/basepak.pk3
	COMMAND ${VLUMPY} ARGS basepak.ls
	DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/basepak.ls vlumpy
		basepak.ls.in
		mapinfo.txt
		sndinfo.txt
	)
add_custom_target(doom1_basepak ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/basepak.pk3)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/basepak.pk3 base.txt
	DESTINATION ${DATADIR}/basev/doom1)

=== basev/doom2/CMakeLists.txt ===
configure_file(basepak.ls.in ${CMAKE_CURRENT_BINARY_DIR}/basepak.ls)

add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/basepak.pk3
	COMMAND ${VLUMPY} ARGS basepak.ls
	DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/basepak.ls vlumpy
		basepak.ls.in
		mapinfo.txt
		${CMAKE_SOURCE_DIR}/progs/doom2/cgame.vc
	)
add_custom_target(doom2_basepak ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/basepak.pk3)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/basepak.pk3 base.txt
	DESTINATION ${DATADIR}/basev/doom2)

=== basev/heretic/CMakeLists.txt ===
configure_file(basepak.ls.in ${CMAKE_CURRENT_BINARY_DIR}/basepak.ls)

add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/basepak.pk3
	COMMAND ${VLUMPY} ARGS basepak.ls
	DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/basepak.ls vlumpy
		graphics/croshai1.lmp
		graphics/croshai2.lmp
		graphics/croshai3.lmp
		graphics/fonta30.lmp
		graphics/fonta63.lmp
		palette.pcx
		basepak.ls.in
		animdefs.txt
		lockdefs.txt
		mapinfo.txt
		skyboxes.txt
		sndinfo.txt
		sndseq.txt
		sprite_rename.txt
		terrain.txt
		${CMAKE_SOURCE_DIR}/progs/heretic/cgame/*.vc
		${CMAKE_SOURCE_DIR}/progs/heretic/game/*.vc
	)
add_custom_target(heretic_basepak ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/basepak.pk3)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/basepak.pk3
	DESTINATION ${DATADIR}/basev/heretic)

=== basev/hexen/CMakeLists.txt ===
configure_file(basepak.ls.in ${CMAKE_CURRENT_BINARY_DIR}/basepak.ls)

add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/basepak.pk3
	COMMAND ${VLUMPY} ARGS basepak.ls
	DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/basepak.ls vlumpy
		graphics/croshai1.lmp
		graphics/croshai2.lmp
		graphics/croshai3.lmp
		graphics/fonta30.lmp
		graphics/fonta63.lmp
		palette.pcx
		basepak.ls.in
		animdefs.txt
		lockdefs.txt
		mapinfo.txt
		skyboxes.txt
		sndinfo.txt
		sprite_rename.txt
		terrain.txt
		${CMAKE_SOURCE_DIR}/progs/hexen/cgame/*.vc
		${CMAKE_SOURCE_DIR}/progs/hexen/game/*.vc
	)
add_custom_target(hexen_basepak ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/basepak.pk3)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/basepak.pk3
	DESTINATION ${DATADIR}/basev/hexen)

=== basev/plutonia/CMakeLists.txt ===
configure_file(basepak.ls.in ${CMAKE_CURRENT_BINARY_DIR}/basepak.ls)

add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/basepak.pk3
	COMMAND ${VLUMPY} ARGS basepak.ls
	DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/basepak.ls vlumpy
		basepak.ls.in
		mapinfo.txt
	)
add_custom_target(plutonia_basepak ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/basepak.pk3)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/basepak.pk3 base.txt
	DESTINATION ${DATADIR}/basev/plutonia)

=== debian/changelog ===
vavoom (1.33-4) unstable; urgency=low

  * Add Provides:  boom-engine (Closes: #683766).

 -- gustavo panizzo <gfa@zumbi.com.ar>  Sat, 22 Sep 2012 01:19:39 -0300

vavoom (1.33-3) unstable; urgency=low

  * libpng migration fixes (Closes: #662531).
  * Description updated (Closes: #662209).
  * Fix FTBFS on GNU/Hurd.
  * Add libjpeg-dev to Build-Deps (Closes: #674339).
  * entries rectified with wrap-and-sort.
  * copyright file updated to comply with machine-readable format, version 1.0.
  * patches standarized to DEP-3.
  * enable hardening build.
  * symlink manpages to save some space.
  * update vcs: lines in control to point at git repository.

 -- gustavo panizzo <gfa@zumbi.com.ar>  Thu, 28 Mar 2012 14:20:50 -0300

vavoom (1.33-2) unstable; urgency=low

  * FreeDoom support on vlaunch, and better support 
    in general (Closes: #661233). 
  * Menu entry added. thanks Pabs (Closes: #661232).
  * Standards version bumped to 3.9.2

 -- gustavo panizzo <gfa@zumbi.com.ar>  Sat, 27 Feb 2012 01:41:09 -0300

vavoom (1.33-1) unstable; urgency=low

  * Initial release (Closes: #598406). 

 -- gustavo panizzo <gfa@zumbi.com.ar>  Thu, 16 Sep 2010 00:41:09 -0300

=== debian/control ===
Source: vavoom
Section: games
Priority: extra
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: gustavo panizzo <gfa@zumbi.com.ar>, Jon Dowland <jmtd@debian.org>
Build-Depends: cmake,
               debhelper (>= 7.0.50~),
               liballegro4.2-dev,
               libflac++-dev,
               libmad0-dev,
               libmikmod2-dev,
               libpng-dev,
               libsdl-mixer1.2-dev,
               libvorbis-dev,
               libwxgtk2.8-dev,
               libjpeg8-dev,
               zlib1g-dev
Standards-Version: 3.9.3
Homepage: http://www.vavoom-engine.com/
Vcs-Browser: http://anonscm.debian.org/git/pkg-games/vavoom.git
Vcs-Git: git://anonscm.debian.org/pkg-games/vavoom.git

Package: vavoom
Provides: doom-engine, heretic-engine, boom-engine
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: freedoom | doom-wad | heretic-wad | game-data-packager | boom-wad
Description: Advanced Doom/Heretic/Hexen/Strife engine
 Vavoom is an engine based on sources of Doom, Heretic, Hexen and
 a little bit from Quake.
 It needs game data to run, A free game data is available in
 freedoom package. Commercial game data can be packaged using
 game-data-packager.
 .
 Vavoom features vlaunch, a graphical launcher.

=== debian/rules ===
#!/usr/bin/make -f

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)


export CPPFLAGS
export CFLAGS
export CXXFLAGS
export LDFLAGS

%:
	dh --buildsystem=cmake $@

override_dh_auto_configure:
	dh_auto_configure -- \
	-DDATADIR=share/games/vavoom \
	-DBINDIR=games \
	-DCMAKE_INSTALL_PREFIX=/usr \
	$(cmake_extra_args)

override_dh_installchangelogs:
	dh_installchangelogs docs/changes3.log

override_dh_install:
	install -d debian/vavoom/usr/lib/vavoom
	mv debian/vavoom/usr/games/vavoom.bin debian/vavoom/usr/lib/vavoom/
	mv debian/vavoom/usr/games/vavoom-dedicated.bin debian/vavoom/usr/lib/vavoom/
	install -d debian/vavoom/usr/share/applications
	mv debian/vavoom.desktop                 debian/vavoom/usr/share/applications/

#override_dh_link:
#	dh_link debian/vavoom/usr/share/man/man6/vavoom.6 debian/vavoom/usr/share/man/man6/vavoom-dedicated.6
#	ln -s debian/vavoom/usr/share/man/man6/vavoom.6 debian/vavoom/usr/share/man/man6/vavoom-dedicated.6
#	ls debian/vavoom/usr/share/man/man6
#	ls usr/share/man/man6

=== debian/watch ===
version=3
http://sf.net/vavoom/vavoom-(.+)\.(?:tar\.(?:gz|bz2|xz))
